// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grbl_msgs:srv/Stop.idl
// generated code does not contain a copyright notice
#include "grbl_msgs/srv/detail/stop__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `machine_id`
// Member `command`
#include "rosidl_runtime_c/string_functions.h"

bool
grbl_msgs__srv__Stop_Request__init(grbl_msgs__srv__Stop_Request * msg)
{
  if (!msg) {
    return false;
  }
  // machine_id
  if (!rosidl_runtime_c__String__init(&msg->machine_id)) {
    grbl_msgs__srv__Stop_Request__fini(msg);
    return false;
  }
  // command
  if (!rosidl_runtime_c__String__init(&msg->command)) {
    grbl_msgs__srv__Stop_Request__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__srv__Stop_Request__fini(grbl_msgs__srv__Stop_Request * msg)
{
  if (!msg) {
    return;
  }
  // machine_id
  rosidl_runtime_c__String__fini(&msg->machine_id);
  // command
  rosidl_runtime_c__String__fini(&msg->command);
}

grbl_msgs__srv__Stop_Request *
grbl_msgs__srv__Stop_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Request * msg = (grbl_msgs__srv__Stop_Request *)allocator.allocate(sizeof(grbl_msgs__srv__Stop_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__srv__Stop_Request));
  bool success = grbl_msgs__srv__Stop_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__srv__Stop_Request__destroy(grbl_msgs__srv__Stop_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grbl_msgs__srv__Stop_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grbl_msgs__srv__Stop_Request__Sequence__init(grbl_msgs__srv__Stop_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Request * data = NULL;

  if (size) {
    data = (grbl_msgs__srv__Stop_Request *)allocator.zero_allocate(size, sizeof(grbl_msgs__srv__Stop_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__srv__Stop_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__srv__Stop_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__srv__Stop_Request__Sequence__fini(grbl_msgs__srv__Stop_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__srv__Stop_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__srv__Stop_Request__Sequence *
grbl_msgs__srv__Stop_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Request__Sequence * array = (grbl_msgs__srv__Stop_Request__Sequence *)allocator.allocate(sizeof(grbl_msgs__srv__Stop_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__srv__Stop_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grbl_msgs__srv__Stop_Request__Sequence__destroy(grbl_msgs__srv__Stop_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grbl_msgs__srv__Stop_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}


bool
grbl_msgs__srv__Stop_Response__init(grbl_msgs__srv__Stop_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
grbl_msgs__srv__Stop_Response__fini(grbl_msgs__srv__Stop_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
}

grbl_msgs__srv__Stop_Response *
grbl_msgs__srv__Stop_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Response * msg = (grbl_msgs__srv__Stop_Response *)allocator.allocate(sizeof(grbl_msgs__srv__Stop_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__srv__Stop_Response));
  bool success = grbl_msgs__srv__Stop_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__srv__Stop_Response__destroy(grbl_msgs__srv__Stop_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    grbl_msgs__srv__Stop_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
grbl_msgs__srv__Stop_Response__Sequence__init(grbl_msgs__srv__Stop_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Response * data = NULL;

  if (size) {
    data = (grbl_msgs__srv__Stop_Response *)allocator.zero_allocate(size, sizeof(grbl_msgs__srv__Stop_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__srv__Stop_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__srv__Stop_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__srv__Stop_Response__Sequence__fini(grbl_msgs__srv__Stop_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__srv__Stop_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__srv__Stop_Response__Sequence *
grbl_msgs__srv__Stop_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  grbl_msgs__srv__Stop_Response__Sequence * array = (grbl_msgs__srv__Stop_Response__Sequence *)allocator.allocate(sizeof(grbl_msgs__srv__Stop_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__srv__Stop_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
grbl_msgs__srv__Stop_Response__Sequence__destroy(grbl_msgs__srv__Stop_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    grbl_msgs__srv__Stop_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
