// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grbl_msgs:srv/Stop.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__SRV__DETAIL__STOP__TRAITS_HPP_
#define GRBL_MSGS__SRV__DETAIL__STOP__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grbl_msgs/srv/detail/stop__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace grbl_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Stop_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: machine_id
  {
    out << "machine_id: ";
    rosidl_generator_traits::value_to_yaml(msg.machine_id, out);
    out << ", ";
  }

  // member: command
  {
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Stop_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: machine_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "machine_id: ";
    rosidl_generator_traits::value_to_yaml(msg.machine_id, out);
    out << "\n";
  }

  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Stop_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::srv::Stop_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::srv::Stop_Request & msg)
{
  return grbl_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::srv::Stop_Request>()
{
  return "grbl_msgs::srv::Stop_Request";
}

template<>
inline const char * name<grbl_msgs::srv::Stop_Request>()
{
  return "grbl_msgs/srv/Stop_Request";
}

template<>
struct has_fixed_size<grbl_msgs::srv::Stop_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::srv::Stop_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::srv::Stop_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace grbl_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const Stop_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Stop_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Stop_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::srv::Stop_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::srv::Stop_Response & msg)
{
  return grbl_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::srv::Stop_Response>()
{
  return "grbl_msgs::srv::Stop_Response";
}

template<>
inline const char * name<grbl_msgs::srv::Stop_Response>()
{
  return "grbl_msgs/srv/Stop_Response";
}

template<>
struct has_fixed_size<grbl_msgs::srv::Stop_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<grbl_msgs::srv::Stop_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<grbl_msgs::srv::Stop_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grbl_msgs::srv::Stop>()
{
  return "grbl_msgs::srv::Stop";
}

template<>
inline const char * name<grbl_msgs::srv::Stop>()
{
  return "grbl_msgs/srv/Stop";
}

template<>
struct has_fixed_size<grbl_msgs::srv::Stop>
  : std::integral_constant<
    bool,
    has_fixed_size<grbl_msgs::srv::Stop_Request>::value &&
    has_fixed_size<grbl_msgs::srv::Stop_Response>::value
  >
{
};

template<>
struct has_bounded_size<grbl_msgs::srv::Stop>
  : std::integral_constant<
    bool,
    has_bounded_size<grbl_msgs::srv::Stop_Request>::value &&
    has_bounded_size<grbl_msgs::srv::Stop_Response>::value
  >
{
};

template<>
struct is_service<grbl_msgs::srv::Stop>
  : std::true_type
{
};

template<>
struct is_service_request<grbl_msgs::srv::Stop_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grbl_msgs::srv::Stop_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GRBL_MSGS__SRV__DETAIL__STOP__TRAITS_HPP_
