// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from grbl_msgs:action/SendGcodeFile.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_H_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'file_path'
#include "rosidl_runtime_c/string.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_Goal
{
  rosidl_runtime_c__String file_path;
} grbl_msgs__action__SendGcodeFile_Goal;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_Goal.
typedef struct grbl_msgs__action__SendGcodeFile_Goal__Sequence
{
  grbl_msgs__action__SendGcodeFile_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_Goal__Sequence;


// Constants defined in the message

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_Result
{
  bool success;
} grbl_msgs__action__SendGcodeFile_Result;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_Result.
typedef struct grbl_msgs__action__SendGcodeFile_Result__Sequence
{
  grbl_msgs__action__SendGcodeFile_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'status'
// already included above
// #include "rosidl_runtime_c/string.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_Feedback
{
  rosidl_runtime_c__String status;
} grbl_msgs__action__SendGcodeFile_Feedback;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_Feedback.
typedef struct grbl_msgs__action__SendGcodeFile_Feedback__Sequence
{
  grbl_msgs__action__SendGcodeFile_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "grbl_msgs/action/detail/send_gcode_file__struct.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  grbl_msgs__action__SendGcodeFile_Goal goal;
} grbl_msgs__action__SendGcodeFile_SendGoal_Request;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_SendGoal_Request.
typedef struct grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} grbl_msgs__action__SendGcodeFile_SendGoal_Response;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_SendGoal_Response.
typedef struct grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} grbl_msgs__action__SendGcodeFile_GetResult_Request;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_GetResult_Request.
typedef struct grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence
{
  grbl_msgs__action__SendGcodeFile_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__struct.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_GetResult_Response
{
  int8_t status;
  grbl_msgs__action__SendGcodeFile_Result result;
} grbl_msgs__action__SendGcodeFile_GetResult_Response;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_GetResult_Response.
typedef struct grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence
{
  grbl_msgs__action__SendGcodeFile_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__struct.h"

// Struct defined in action/SendGcodeFile in the package grbl_msgs.
typedef struct grbl_msgs__action__SendGcodeFile_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  grbl_msgs__action__SendGcodeFile_Feedback feedback;
} grbl_msgs__action__SendGcodeFile_FeedbackMessage;

// Struct for a sequence of grbl_msgs__action__SendGcodeFile_FeedbackMessage.
typedef struct grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence
{
  grbl_msgs__action__SendGcodeFile_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_FILE__STRUCT_H_
